Unit GameStat;

Interface

Uses Keyboard,G320,AtariDbg;

Procedure GameStatus(Width,Height: Word; Var Difficulty1,Difficulty2: LongInt; Var AutoCenter: Byte);

Implementation

Const
  _32BIT_OPERAND = $66;

Procedure GameStatus(Width,Height: Word; Var Difficulty1,Difficulty2: LongInt; Var AutoCenter: Byte);
Var
  Buf     : Pointer;
  BufSize : LongInt;
  St : String;

  Procedure Dim(BufSize: Word); Assembler;
  Asm
    MOV   AX,0A000h
    MOV   ES,AX
    MOV   CX,WORD PTR BufSize
    SHR   CX,1
    SUB   DI,DI
  @L1:
    MOV   DX,WORD PTR [ES:DI]
    MOV   BX,DX
    AND   BX,0E0Eh
    AND   DX,0F0F0h

    OR    BL,BL
    JZ    @L2
    SHR   BL,2
    CMP   BL,2
    JGE   @L2
    MOV   BL,2
@L2:
    OR    BH,BH
    JZ    @L3
    SHR   BH,2
    CMP   BH,2
    JGE   @L3
    MOV   BH,2
@L3:
    OR    DX,BX
    MOV   WORD PTR [ES:DI],DX
    ADD   DI,2
    LOOP  @L1
  End; { Dim }

  Procedure DrawWindow(X1,Y1,X2,Y2: Word; BK,C1,C2: Byte; Width: Word);
  Const BorderWidth = 5;
  Var
    X,Y   : Word;
    Addr1 : Word;
    Addr2 : Word;
    CInc  : Integer;

  Begin
    BK := BK Shl 1;
    C1 := C1 Shl 1;
    C2 := C2 Shl 1;

    { Draw top and bottom borders }

    For Y := 0 To BorderWidth - 1 Do
    Begin
      Addr1 := Width * (Y1 + Y);
      Addr2 := Width * (Y2 + Y - BorderWidth + 1);
      CInc  := 2 * ((BorderWidth Div 2) - Abs((BorderWidth Div 2) - Integer(Y)));
      For X := X1 + 1 To X2 - 1 Do
      Begin
        If ((X + Y + Y1) And 2) <> 0
         Then Mem[$A000:Addr1 + X] := C1 + CInc
         Else Mem[$A000:Addr1 + X] := C2 + CInc;
        If ((X + Y + Y2 - BorderWidth + 1) And 2) <> 0
         Then Mem[$A000:Addr2 + X] := C1 + CInc
         Else Mem[$A000:Addr2 + X] := C2 + CInc;
      End; { For X }
    End; { For Y }

    { Draw left and right borders }

    For Y := Y1 + 1 To Y2 - 1 Do
    Begin
      Addr1 := Width * Y;
      For X := X1 To X1 + BorderWidth - 1 Do
      Begin
        CInc  := 2 * ((BorderWidth Div 2) - Abs((BorderWidth Div 2) - Integer(X - X1)));
        If ((X + Y) And 2) <> 0
         Then Mem[$A000:Addr1 + X] := C1 + CInc
         Else Mem[$A000:Addr1 + X] := C2 + CInc;
      End; { For X }
      For X := X2 - BorderWidth + 1 To X2 Do
      Begin
        CInc  := 2 * ((BorderWidth Div 2) - Abs((BorderWidth Div 2) - Integer(X - (X2 - BorderWidth + 1))));
        If ((X + Y) And 2) <> 0
         Then Mem[$A000:Addr1 + X] := C1 + CInc
         Else Mem[$A000:Addr1 + X] := C2 + CInc;
      End; { For X }
    End; { For Y }

    { Draw center area }

    For Y := Y1 + BorderWidth To Y2 - BorderWidth Do
     FillChar(Mem[$A000:Width * Y + X1 + BorderWidth],X2 - X1 - 2 * BorderWidth + 1,BK);
  End; { DrawWindow }

  Procedure PutChar(X,Y: Word; C: Char; Color,Width: Word); Assembler;
  Asm
    MOV   AX,WORD PTR Y
{
    SUB   BX,BX
    MOV   BH,AL
    SHL   AX,6
    ADD   BX,AX
    MOV   DI,BX
}
    MUL   WORD PTR Width
    MOV   DI,AX
    ADD   DI,WORD PTR X
    PUSH  DS
    LDS   SI,DWORD PTR FontPtr
    MOV   AL,BYTE PTR C
    SUB   AH,AH
    SHL   AX,3
    ADD   SI,AX
    MOV   AX,0A000h
    MOV   ES,AX
    MOV   AL,8
    ADD   DI,7
    MOV   DX,WORD PTR Color
  @Loop:
    MOV   BH,BYTE PTR [SI]
    MOV   CX,8
    MOV   BL,1
  @L1:
    TEST  BH,BL
    JZ    @L2
    MOV   BYTE PTR [ES:DI],DL
    DEC   DI
    ADD   BL,BL
    LOOP  @L1
    ADD   DI,WORD PTR Width
    INC   SI
    ADD   DI,8
    DEC   AL
    JNZ   @Loop
    POP   DS
    JMP   @L3
  @L2:
    MOV   BYTE PTR [ES:DI],DH
    DEC   DI
    ADD   BL,BL
    LOOP  @L1
    ADD   DI,WORD PTR Width
    INC   SI
    ADD   DI,8
    DEC   AL
    JNZ   @Loop
    POP   DS
  @L3:
  End; { PutChar }

  Procedure WriteOut(X,Y: Word; St: String; Color,Width: Word);
  Var I: Byte;
  Begin
    If St = '' Then Exit;
    For I := 0 To Length(St) - 1 Do PutChar(X + (I * 8),Y,St[I + 1],Color,Width);
  End; { WriteOut }

  Procedure PutSmChar(X,Y: Word; C: Char; Color,Width: Word); Assembler;
  Asm
    MOV   AX,WORD PTR Y
    MUL   WORD PTR Width
    MOV   DI,AX
    ADD   DI,WORD PTR X
    PUSH  DS
    LDS   SI,DWORD PTR FontSmPtr
    MOV   AL,BYTE PTR C
    SUB   AH,AH
    SHL   AX,3
    ADD   SI,AX
    MOV   AX,0A000h
    MOV   ES,AX
    MOV   AL,8
    ADD   DI,7
    MOV   DX,WORD PTR Color
  @Loop:
    MOV   BH,BYTE PTR [SI]
    MOV   CX,6
    MOV   BL,4
  @L1:
    TEST  BH,BL
    JZ    @L2
    MOV   BYTE PTR [ES:DI],DL
    DEC   DI
    ADD   BL,BL
    LOOP  @L1
    ADD   DI,WORD PTR Width
    INC   SI
    ADD   DI,6
    DEC   AL
    JNZ   @Loop
    POP   DS
    JMP   @L3
  @L2:
    MOV   BYTE PTR [ES:DI],DH
    DEC   DI
    ADD   BL,BL
    LOOP  @L1
    ADD   DI,WORD PTR Width
    INC   SI
    ADD   DI,6
    DEC   AL
    JNZ   @Loop
    POP   DS
  @L3:
  End; { PutSmChar }

  Procedure WriteSmOut(X,Y: Word; St: String; Color,Width: Word);
  Var I: Byte;
  Begin
    If St = '' Then Exit;
    For I := 0 To Length(St) - 1 Do PutSmChar(X + (I * 6),Y,St[I + 1],Color,Width);
  End; { WriteSmOut }

  Procedure DrawDiff(X,Y: Word; Diff: Boolean; Width: Word);
  Begin
    If Diff Then WriteOut(X,Y,'A',$089F,Width) Else WriteOut(X,Y,'B',$089F,Width);
  End; { DrawDiff }

  Procedure DrawYN(X,Y: Word; Diff: Boolean; Width: Word);
  Begin
    If Diff Then WriteOut(X,Y,'Y',$089F,Width) Else WriteOut(X,Y,'N',$089F,Width);
  End; { DrawDiff }

Begin
  BufSize := Width * Height;
  GetMem(Buf,BufSize);
  Move(Mem[$A000:0],Buf^,BufSize);
  Key[kEsc] := 0;
  Dim(BufSize);                { Dim the screen }
  If Width = 320 Then
  Begin
    DrawWindow(100,30,220,170,4,5,28,Width);
    WriteOut(108,39,'PCAE 2.0',$081E,Width);
    WriteSmOut(108,55, 'Esc - Exit game',$0800,Width);
    WriteSmOut(108,65, 'F1  - Help',$0800,Width);
    WriteSmOut(108,75, 'F2  - Reset',$0800,Width);
    WriteSmOut(108,85, 'F3  - Toggle PAL',$0800,Width);
    WriteSmOut(108,95, 'F4  - Select',$0800,Width);
    WriteSmOut(108,105,'F5  - Color/BW',$0800,Width);
    WriteSmOut(108,115,'F6  - P1 diff.',$0886,Width);
    WriteSmOut(108,125,'F7  - P2 diff.',$0886,Width);
    WriteSmOut(108,135,'-   - Shift down',$0800,Width);
    WriteSmOut(108,145,'=   - Shift up',$0800,Width);
    WriteSmOut(108,155,'F10 - A.Center',$0886,Width);
    DrawDiff(200,115,((Difficulty1 And $40) <> 0),Width);
    DrawDiff(200,125,((Difficulty2 And $80) <> 0),Width);
    DrawYN(200,155,(AutoCenter <> 0),Width);
  End
  Else
  Begin
    DrawWindow(20,30,140,170,4,5,28,Width);
    WriteOut(28,39,'PCAE 2.0',$081E,Width);
    WriteSmOut(28,55, 'Esc - Exit game',$0800,Width);
    WriteSmOut(28,65, 'F1  - Help',$0800,Width);
    WriteSmOut(28,75, 'F2  - Reset',$0800,Width);
    WriteSmOut(28,85, 'F3  - Toggle PAL',$0800,Width);
    WriteSmOut(28,95, 'F4  - Select',$0800,Width);
    WriteSmOut(28,105,'F5  - Color/BW',$0800,Width);
    WriteSmOut(28,115,'F6  - P1 diff.',$0886,Width);
    WriteSmOut(28,125,'F7  - P2 diff.',$0886,Width);
    WriteSmOut(28,135,'-   - Shift down',$0800,Width);
    WriteSmOut(28,145,'=   - Shift up',$0800,Width);
    WriteSmOut(28,155,'F10 - A.Center',$0886,Width);
    DrawDiff(120,115,((Difficulty1 And $40) <> 0),Width);
    DrawDiff(120,125,((Difficulty2 And $80) <> 0),Width);
    DrawYN(120,155,(AutoCenter <> 0),Width);
  End;
  Repeat
    If Key[kF6] <> 0 Then
    Begin
      Difficulty1 := Difficulty1 Xor $40;
      If Width = 320
       Then DrawDiff(200,115,((Difficulty1 And $40) <> 0),Width)
       Else DrawDiff(120,115,((Difficulty1 And $40) <> 0),Width);
      Key[kF6] := 0;
    End;
    If Key[kF7] <> 0 Then
    Begin
      Difficulty2 := Difficulty2 Xor $80;
      If Width = 320
       Then DrawDiff(200,125,((Difficulty2 And $80) <> 0),Width)
       Else DrawDiff(120,125,((Difficulty2 And $80) <> 0),Width);
      Key[kF7] := 0;
    End;
    If Key[kF10] <> 0 Then
    Begin
      AutoCenter := AutoCenter Xor 1;
      If Width = 320
       Then DrawYN(200,155,(AutoCenter <> 0),Width)
       Else DrawYN(120,155,(AutoCenter <> 0),Width);
      Key[kF10] := 0;
    End;
  Until Key[kEsc] <> 0;
  Repeat
  Until Key[kEsc] = 0;
  Move(Buf^,Mem[$A000:0],BufSize);
  FreeMem(Buf,BufSize);
End; { GameStatus }

End.
